/*
  ******************************************************************************
  * @file    apt32f103.c
  * @author  
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "apt32f103.h"


/**
  * @addtogroup Struct pointer assignment Functions
  * @{
  */
//E902
CLIC_Type 	*CLIC 	= (CLIC_Type*)(CLIC_BASE);
CLINT_Type 	*CLINT	= (CLINT_Type*)(CLINT_BASE);
CORET_Type 	*CORET  = (CORET_Type*)(CORET_BASE);
DCC_Type 	*DCC    = (DCC_Type*)(DCC_BASE);
SYSMAP_Type *SYSMAP = (SYSMAP_Type*)(SYSMAP_BASE);

//EXT IP
CSP_IFC_T   	*IFC     = (CSP_IFC_T    *)APB_IFC_BASE ;
CSP_SYSCON_T 	*SYSCON = (CSP_SYSCON_T *)APB_SYS_BASE ;

CSP_TKEY_T  	*TKEY    		= (CSP_TKEY_T  *)APB_TKEY_BASE ;
CSP_TKEYBUF1_T   *TKEYBUF1 		= (CSP_TKEYBUF1_T  *)APB_TKDAT_BASE;
CSP_TKEYBUF2_T  *TKEYBUF2 = (CSP_TKEYBUF2_T *)APB_TKSEQxCON_BASE;

CSP_ADC12_T 	*ADC0    = (CSP_ADC12_T  *)APB_ADC0_BASE ;

CSP_GPIO_T  	*GPIOA0   = (CSP_GPIO_T  *)APB_GPIOA0_BASE ; // A0
CSP_GPIO_T  	*GPIOB0   = (CSP_GPIO_T  *)APB_GPIOB0_BASE ; // B0
CSP_IGRP_T  	*GPIOGRP  = (CSP_IGRP_T *)APB_IGRP_BASE;

CSP_UART_T  	*UART0    = (CSP_UART_T  *)APB_UART0_BASE ;
CSP_UART_T  	*UART1    = (CSP_UART_T  *)APB_UART1_BASE ;
CSP_UART_T  	*UART2    = (CSP_UART_T  *)APB_UART2_BASE ;
CSP_USART_T  	*USART0    = (CSP_USART_T  *)APB_USART0_BASE ;
CSP_SSP_T   	*SPI0     = (CSP_SSP_T   *)APB_SPI0_BASE ;
CSP_I2C_T   	*I2C0     = (CSP_I2C_T   *)APB_I2C0_BASE ;
CSP_SIO_T   	*SIO0     = (CSP_SIO_T   *)APB_SIO0_BASE ;
CSP_CA_T    	*CA0      = (CSP_CA_T    *)APB_CNTA_BASE ;

CSP_GPTA_T		*GPTA0	  =	(CSP_GPTA_T *)APB_GPTA0_BASE;

CSP_EPT_T   	*EPT0     = (CSP_EPT_T  *)APB_EPT0_BASE ;
CSP_ETCB_T  	*ETCB     = (CSP_ETCB_T *)APB_ETCB_BASE ;
CSP_RTC_T   	*RTC      = (CSP_RTC_T  *)APB_RTC_BASE ;
CSP_LPT_T   	*LPT      = (CSP_LPT_T  *)APB_LPT_BASE ;
CSP_WWDT_T   	*WWDT      = (CSP_WWDT_T  *)APB_WWDT_BASE ;
CSP_BT_T    	*BT0      = (CSP_BT_T   *)APB_BT0_BASE ;
CSP_BT_T    	*BT1      = (CSP_BT_T   *)APB_BT1_BASE ;
CSP_BT_T    	*BT2      = (CSP_BT_T   *)APB_BT2_BASE ;
CSP_BT_T    	*BT3      = (CSP_BT_T   *)APB_BT3_BASE ;
CSP_CRC_T   	*CRC      = (CSP_CRC_T  *)AHB_CRC_BASE ;
CSP_HWD_T   	*HWD      = (CSP_HWD_T  *)AHB_HWD_BASE ;

CSP_DMA_T		*DMA		= (CSP_DMA_T *)(AHB_DMA_BASE);
CSP_DMA_T 		*DMA0     	= (CSP_DMA_T *)(APB_DMA0_BASE);
CSP_DMA_T 		*DMA1     	= (CSP_DMA_T *)(APB_DMA1_BASE);
CSP_DMA_T 		*DMA2     	= (CSP_DMA_T *)(APB_DMA2_BASE);
CSP_DMA_T 		*DMA3     	= (CSP_DMA_T *)(APB_DMA3_BASE);
CSP_DMA_T 		*DMA4     	= (CSP_DMA_T *)(APB_DMA4_BASE);
CSP_DMA_T 		*DMA5     	= (CSP_DMA_T *)(APB_DMA5_BASE);

int __divsi3 (  int a,   int b)
{   
	int PSR,QWE;
	PSR= __get_MSTATUS();
	__disable_irq();

	HWD->CR = 0;
	HWD->DIVIDENT = a;
	HWD->DIVISOR = b;
	QWE=HWD->QUOTIENT;

	__set_MSTATUS(PSR);				
	return QWE;
}
 unsigned int __udivsi3 ( unsigned int a,  unsigned int b)
{   
	int PSR,QWE;
	PSR= __get_MSTATUS();
	__disable_irq();
	
	HWD->CR = 1;
	HWD->DIVIDENT = a;
	HWD->DIVISOR = b;
	QWE=HWD->QUOTIENT;

	__set_MSTATUS(PSR);				

	return QWE;
}

int __modsi3 ( int a,  int b)
{   
	int PSR,QWE;
	PSR= __get_MSTATUS();
	__disable_irq();
	
	HWD->CR = 0;
	HWD->DIVIDENT = a;
	HWD->DIVISOR = b;
	QWE=HWD->REMAIN;

	__set_MSTATUS(PSR);			
	return QWE;
}

unsigned int __umodsi3 ( unsigned int a,  unsigned int b)
{   
	int PSR,QWE;
	PSR= __get_MSTATUS();
	__disable_irq();
	
	HWD->CR = 1;
	HWD->DIVIDENT = a;
	HWD->DIVISOR = b;
	QWE=HWD->REMAIN;

	__set_MSTATUS(PSR);		
	return QWE;
}

/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/