/*
  ******************************************************************************
  * @file    apt32f103_initial.c
  * @author  
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/ 
/* Includes ------------------------------------------------------------------*/
#include "apt32f103.h"
#include "apt32f103_adc.h"
#include "apt32f103_bt.h"
#include "apt32f103_countera.h"
#include "apt32f103_crc.h"
#include "apt32f103_ept.h"
#include "apt32f103_et.h"
#include "apt32f103_gpio.h"
#include "apt32f103_gpt.h"
#include "apt32f103_i2c.h"
#include "apt32f103_ifc.h"
#include "apt32f103_lpt.h"
#include "apt32f103_rtc.h"
#include "apt32f103_sio.h"
#include "apt32f103_spi.h"
#include "apt32f103_syscon.h"
#include "apt32f103_uart.h"
#include "apt32f103_usart.h"
#include "apt32f103_wwdt.h"
#include "apt32f103_dma.h"
#include "apt32f103_types_local.h"
#include "tkey.h"
/* define --------------------------------------------------------------------*/
/* externs--------------------------------------------------------------------*/
extern void tkey_basetime_init(U16_T basecnt_ms);


/*************************************************************/
//software delay
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void delay_nms(unsigned int t)
{
    volatile unsigned int i,j ,k=0;
    j = 50* t;
    for ( i = 0; i < j; i++ )
    {
        k++;
		SYSCON_IWDCNT_Reload(); 
    }
}

void delay_nus(unsigned int t)
{
    volatile unsigned int i,j ,k=0;
    j = 1* t;
    for ( i = 0; i < j; i++ )
    {
        k++;
    }
}
/*************************************************************/
//GPIO Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void GPIO_CONFIG(void)
{
	GPIO_Init(GPIOA0,1,0);
	GPIO_Write_High(GPIOA0,1);				
	GPIO_Write_Low(GPIOA0,1);

	GPIO_Init(GPIOA0,0,0);	
	GPIO_Write_High(GPIOA0,0);				
	GPIO_Write_Low(GPIOA0,0);		
	//GPIO_PullHigh_Init(GPIOA0,0);
//------------  EXI FUNTION  --------------------------------/
//EXI0_INT= EXI0/EXI16,EXI1_INT= EXI1/EXI17, EXI2_INT=EXI2~EXI3/EXI18/EXI19, EXI3_INT=EXI4~EXI9, EXI4_INT=EXI10~EXI15    
	//GPIO_IntGroup_Set(PA0,0,Selete_EXI_PIN0);								//EXI0 set PBA.0
	//GPIOA0_EXI_Init(EXI0);                                   	//PA0.0 as input
	//EXTI_trigger_CMD(ENABLE,EXI_PIN0,_EXIFT);                  	//ENABLE falling edge
	//EXTI_trigger_CMD(ENABLE,EXI_PIN0,_EXIRT);                 //ENABLE rising edge
    //EXTI_interrupt_CMD(ENABLE,EXI_PIN0);                	   	//enable EXI
    //GPIO_EXTI_interrupt(GPIOA0,0b00000000000001);				//enable GPIOA00 as EXI
	//EXI0_Int_Enable();                                         	//EXI0 INT Vector
    //EXI1_Int_Enable();                                        //EXI1 INT Vector
    //EXI2_Int_Enable();                                        //EXI2~EXI3 INT Vector
    //EXI3_Int_Enable();                                        //EXI4~EXI8 INT Vector
    //EXI4_Int_Enable();                                        //EXI9~EXI13 INT Vector
}
/*************************************************************/
//ETP0 Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void EPT0_CONFIG(void)
{
	EPT_Software_Prg();								//EPT software reset
//------------  EPT GPIO Setting  --------------------------------/
	EPT_IO_SET(EPT_IO_CHAX,IO_NUM_CHAX_PB0_6);
	EPT_IO_SET(EPT_IO_CHAY,IO_NUM_CHAY_PB0_7);
	EPT_IO_SET(EPT_IO_CHBX,IO_NUM_CHBX_PB0_8);
	EPT_IO_SET(EPT_IO_CHBY,IO_NUM_CHBY_PB0_9);
	EPT_IO_SET(EPT_IO_CHCX,IO_NUM_CHCX_PB0_5);
	EPT_IO_SET(EPT_IO_CHCY,IO_NUM_CHCY_PB0_4);
	EPT_IO_SET(EPT_IO_CHD,IO_NUM_CHD_PB0_3);
	
	//EPT_IO_SET(EPT_IO_EBI,EBI0_IO_PB0_12);//EBI0
	//EPT_IO_SET(EPT_IO_EBI,EBI1_IO_PA0_13);//EBI1
	//EPT_IO_SET(EPT_IO_EBI,EBI2_IO_PB0_3);//EBI2
	//EPT_IO_SET(EPT_IO_EBI,EBI3_IO_PB0_2);//EBI3
	
//------------  EPT Control  --------------------------------/
	EPT_PWM_Config(EPT_Selecte_PCLK,EPT_CNTMD_increase,EPT_OPM_Continue,0);//PCLK as clock，increasing mode,continuous mode,TCLK=PCLK/(0+1) 
	//EPT_Tevent_Selecte(0x00,0x00);				//T1 source selection SYNCIN4,T2 source selection SYNCIN5
	//EPT_SYNCR_Config(0x00,EPT_SYNCUSR0_REARMTrig_DIS,EPT_TRGSRC0_ExtSync_SYNCUSR0,EPT_TRGSRC1_ExtSync_SYNCUSR4,0x3f);//enable SYNCUSR4 SYNCUSR5 as trigger event,continuous mode
	EPT_PWMX_Output_Control(EPT_PWMA,EPT_CA_Selecte_CMPA,EPT_CB_Selecte_CMPA,EPT_PWM_ZRO_Event_OutHigh,EPT_PWM_PRD_Event_Nochange,EPT_PWM_CAU_Event_OutLow,EPT_PWM_CAD_Event_OutLow,
							EPT_PWM_CBU_Event_Nochange,EPT_PWM_CBD_Event_Nochange,EPT_PWM_T1U_Event_Nochange,EPT_PWM_T1D_Event_Nochange,EPT_PWM_T2U_Event_Nochange,EPT_PWM_T2D_Event_Nochange);
	EPT_PWMX_Output_Control(EPT_PWMB,EPT_CA_Selecte_CMPB,EPT_CB_Selecte_CMPB,EPT_PWM_ZRO_Event_OutHigh,EPT_PWM_PRD_Event_Nochange,EPT_PWM_CAU_Event_OutLow,EPT_PWM_CAD_Event_OutLow,
							EPT_PWM_CBU_Event_Nochange,EPT_PWM_CBD_Event_Nochange,EPT_PWM_T1U_Event_Nochange,EPT_PWM_T1D_Event_Nochange,EPT_PWM_T2U_Event_Nochange,EPT_PWM_T2D_Event_Nochange);						
	EPT_PWMX_Output_Control(EPT_PWMC,EPT_CA_Selecte_CMPC,EPT_CB_Selecte_CMPC,EPT_PWM_ZRO_Event_OutHigh,EPT_PWM_PRD_Event_Nochange,EPT_PWM_CAU_Event_OutLow,EPT_PWM_CAD_Event_OutLow,
							EPT_PWM_CBU_Event_Nochange,EPT_PWM_CBD_Event_Nochange,EPT_PWM_T1U_Event_Nochange,EPT_PWM_T1D_Event_Nochange,EPT_PWM_T2U_Event_Nochange,EPT_PWM_T2D_Event_Nochange);	
	EPT_PWMX_Output_Control(EPT_PWMD,EPT_CA_Selecte_CMPD,EPT_CB_Selecte_CMPD,EPT_PWM_ZRO_Event_OutHigh,EPT_PWM_PRD_Event_Nochange,EPT_PWM_CAU_Event_OutLow,EPT_PWM_CAD_Event_OutLow,
							EPT_PWM_CBU_Event_Nochange,EPT_PWM_CBD_Event_Nochange,EPT_PWM_T1U_Event_Nochange,EPT_PWM_T1D_Event_Nochange,EPT_PWM_T2U_Event_Nochange,EPT_PWM_T2D_Event_Nochange);		
	EPT_PRDR_CMPA_CMPB_CMPC_CMPD_Config(4800,2400,1200,600,0);//PRDR=4800,CMPA=2400,CMPB=1200,CMPC=600,CMPD=0	
	EPT_DB_CLK_Config(0,24,24);//Fdbclk=Fhclk/(0+1)，DTR=24clk，DTF=24clk
	EPT_DBCR_Config(EPT_CHA_Selecte,EPT_CHAINSEL_PWMA_RISE_FALL,EPT_CHA_OUTSEL_EnRise_EnFall,EPT_PB_OUT_Reverse,EPT_PAtoCHX_PBtoCHY);//PWMA Complementary,CHX rising edge,CHY falling edge		
	EPT_DBCR_Config(EPT_CHB_Selecte,EPT_CHBINSEL_PWMB_RISE_FALL,EPT_CHB_OUTSEL_EnRise_EnFall,EPT_PB_OUT_Reverse,EPT_PAtoCHX_PBtoCHY);//PWMB Complementary,CHX rising edge,CHY falling edge		
	EPT_DBCR_Config(EPT_CHC_Selecte,EPT_CHCINSEL_PWMC_RISE_FALL,EPT_CHC_OUTSEL_EnRise_EnFall,EPT_PB_OUT_Reverse,EPT_PAtoCHX_PBtoCHY);//PWMC Complementary,CHX rising edge,CHY falling edge
	//EPT_CG_gate_Config(EPT_CGSRC_CHBX,0,0,EPT_BURST_ENABLE);//CG选择BT0OUT为输入源，CFFLT=PLCK/(0+1),滤波次数Bypass
	//EPT_CPCR_Config(0X3F,EPT_CPCR_Source_TCLK,EPT_CDUTY_7_8,3,5);//使能CHAX~CHCY斩波输出，TCLK为CPCR时钟源，duty为7/8，起始头为3*Tchop，Fchop=pclk/((5+1)*8)
//------------  EPT0 REG LINK  ----------------------------------/	
	//EPT_REG_LINK_CONFIG(EPT_LinkREG_PRDR,EPT0_GPTA0_LINK);//EPT0->PRDR链接到GPTA0->PRDR
	//EPT_REG_LINK_CONFIG(EPT_LinkREG_CMPA,EPT0_GPTA0_LINK);//EPT0->PRDR链接到GPTA0->CMPA
	//EPT_REG_LINK_CONFIG(EPT_LinkREG_CMPB,EPT0_GPTA0_LINK);//EPT0->PRDR链接到GPTA0->CMPB
	//EPT_REG_LINK_CONFIG(EPT_LinkREG_RSSR,EPT0_GPTA0_LINK);//EPT0->RSSR链接到GPTA0->RSSR
//------------  EPT EM Config	----------------------------------/
	//EPT_EPX_Config(EPT_EP0,EPT_Input_selecte_EBI0,EPT_FLT_PACE0_DIS,EPT_FLT_PACE1_DIS,0,0);//EP0选择EBI0作为输入，EP0~EP3禁止滤波，EP4~EP7禁止滤波
	//EPT_EPX_Config(EPT_EP1,EPT_Input_selecte_EBI1,EPT_FLT_PACE0_DIS,EPT_FLT_PACE1_DIS,0,0);//EP0选择EBI1作为输入，EP0~EP3禁止滤波，EP4~EP7禁止滤波
	//EPT_EPX_Config(EPT_EP2,EPT_Input_selecte_EBI2,EPT_FLT_PACE0_DIS,EPT_FLT_PACE1_DIS,0,0);//EP0选择EBI2作为输入，EP0~EP3禁止滤波，EP4~EP7禁止滤波
	//EPT_EPX_Config(EPT_EP3,EPT_Input_selecte_EBI3,EPT_FLT_PACE0_DIS,EPT_FLT_PACE1_DIS,0,0);//EP0选择EBI3作为输入，EP0~EP3禁止滤波，EP4~EP7禁止滤波
	
	//EPT_EBIX_POL_Config(0X1F);//低电平有效
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP0,EPT_LKCR_Mode_HLOCK_EN);//EP0配置为硬锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP1,EPT_LKCR_Mode_SLOCK_EN);//EP1配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP2,EPT_LKCR_Mode_SLOCK_EN);//EP2配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP3,EPT_LKCR_Mode_SLOCK_EN);//EP3配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP4,EPT_LKCR_Mode_SLOCK_EN);//EP4配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP5,EPT_LKCR_Mode_SLOCK_EN);//EP5配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP6,EPT_LKCR_Mode_SLOCK_EN);//EP6配置为软锁止
	//EPT_LKCR_TRG_Config(EPT_LKCR_TRG_EP7,EPT_LKCR_Mode_SLOCK_EN);//EP7配置为软锁止
	
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHAX,EPT_SHLOCK_OUTPUT_HImpedance);	//产生锁止后CHAX高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHAY,EPT_SHLOCK_OUTPUT_HImpedance); //产生锁止后CHAY高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHBX,EPT_SHLOCK_OUTPUT_HImpedance); //产生锁止后CHBX高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHBY,EPT_SHLOCK_OUTPUT_HImpedance); //产生锁止后CHBY高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHCX,EPT_SHLOCK_OUTPUT_HImpedance); //产生锁止后CHCX高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Channel_CHCY,EPT_SHLOCK_OUTPUT_HImpedance); //产生锁止后CHCY高组态
	//EPT_SHLOCK_OUTPUT_Config(EPT_OUTPUT_Czuotiahannel_CHD,EPT_SHLOCK_OUTPUT_HImpedance);  //产生锁止后CHD高组态
//------------  EPT EM interruption  -----------------------------/
	//EPT_EMInt_Enable(EPT_EP0_EMINT);	
	//EPT_EMInt_Enable(EPT_EP1_EMINT);	
	//EPT_EMInt_Enable(EPT_EP2_EMINT);	
	//EPT_EMInt_Enable(EPT_EP3_EMINT);	
	//EPT_EMInt_Enable(EPT_EP4_EMINT);	
	//EPT_EMInt_Enable(EPT_EP5_EMINT);	
	//EPT_EMInt_Enable(EPT_EP6_EMINT);	
	//EPT_EMInt_Enable(EPT_EP7_EMINT);
//------------  EPT TRGSRC interruption  -----------------------------/	
	//EPT_TRGSRCX_Config(EPT_TRGSRC0,EPT_EVTRG_TRGSRCX_CMPAU,EPT_TRGSRCX_EN,0);//选择CMPAU作为TRGSRC0事件源，事件计数CNT=0
	//EPT_TRGSRCX_Config(EPT_TRGSRC1,EPT_EVTRG_TRGSRCX_CMPBU,EPT_TRGSRCX_EN,0);//选择CMPBU作为TRGSRC1事件源，事件计数CNT=0
	//EPT_TRGSRCX_Config(EPT_TRGSRC2,EPT_EVTRG_TRGSRCX_CMPCU,EPT_TRGSRCX_EN,0);//选择CMPCU作为TRGSRC2事件源，事件计数CNT=0
	//EPT_TRGSRCX_Config(EPT_TRGSRC3,EPT_EVTRG_TRGSRCX_CMPDU,EPT_TRGSRCX_EN,0);//选择CMPDU作为TRGSRC3事件源，事件计数CNT=0
//------------  EPT interruption  --------------------------------/
	//EPT_Int_Enable(EPT_CAP_LD0);//CMPA load interrupt
	//EPT_Int_Enable(EPT_CAP_LD1);//CMPB load interrupt
	//EPT_Int_Enable(EPT_CAP_LD2);//CMPC load interrupt
	//EPT_Int_Enable(EPT_CAP_LD3);//CMPD load interrupt	
	//EPT_Int_Enable(EPT_CAU);//Up-Counting phase CNT = CMPA interrupt request raw status
	//EPT_Int_Enable(EPT_CAD);//Down-Counting phase CNT = CMPA interrupt request raw statu
	//EPT_Int_Enable(EPT_CBU);//Up-Counting phase CNT = CMPB interrupt request raw status
	//EPT_Int_Enable(EPT_CBD);//Down-Counting phase CNT = CMPB interrupt request raw status
	//EPT_Int_Enable(EPT_CCU);//Up-Counting phase CNT = CMPC interrupt request raw status
	//EPT_Int_Enable(EPT_CCD);//Down-Counting phase CNT = CMPC interrupt request raw status
	//EPT_Int_Enable(EPT_CDU);//Up-Counting phase CNT = CMPD interrupt request raw status
	//EPT_Int_Enable(EPT_CDD);//Down-Counting phase CNT = CMPD interrupt request raw status
	//EPT_Int_Enable(EPT_PEND);//End of cycle interrupt request raw status
	//EPT_Int_Enable(EPT_TRGEV0_INT);//TRGEV0
	//EPT_Int_Enable(EPT_TRGEV1_INT);//TRGEV1
	//EPT_Int_Enable(EPT_TRGEV2_INT);//TRGEV2
	//EPT_Int_Enable(EPT_TRGEV3_INT);//TRGEV3
	//EPT_Vector_Int_Enable();
//------------  EPT start  --------------------------------/	
	EPT_Start();
//------------  EPT capture config  --------------------------------/
	/*EPT_Software_Prg();
	EPT_Capture_Config(EPT_Selecte_PCLK,EPT_CNTMD_increase,EPT_CAPMD_Continue,EPT_CAP_EN,EPT_LDARST_EN,EPT_LDBRST_DIS,EPT_LDCRST_DIS,EPT_LDDRST_DIS,1,0);//TCLK=pclk/(1+0),CMPAload CMPBload
	EPT_SYNCR_Config(EPT_Triggle_Continue,EPT_SYNCUSR0_REARMTrig_DIS,EPT_TRGSRC0_ExtSync_SYNCUSR0,EPT_TRGSRC1_ExtSync_SYNCUSR4,0x04);//Enable SYNCUSR2 ,Continuous trigger
	EPT_PRDR_CMPA_CMPB_CMPC_CMPD_Config(0XFFFF,0,0,0,0);
	EPT_Int_Enable(EPT_CAP_LD0);//Capture Load to CMPA interrupt request raw status
	EPT_Int_Enable(EPT_CAP_LD1);//Capture Load to CMPB interrupt request raw status
	EPT_Vector_Int_Enable();
	EPT_Start();*/
}
/*************************************************************/
//GPTA0 Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void GPTA0_CONFIG(void)
{
	GPT_Soft_Reset(GPTA0);								//GPTA0 software reset
//------------  GPTA0 GPIO Setting  --------------------------------/
	GPTA0_IO_Init(GPTA0_CHA_PB0_12);		
	GPTA0_IO_Init(GPTA0_CHB_PB0_13);			
//------------  GPTA0 Control  --------------------------------/
	GPT_PWM_Config(GPTA0,GPT_Selecte_PCLK,GPT_CNTMD_increase,GPT_OPM_Continue,0);//PCLK as clock，increasing mode,continuous mode,TCLK=PCLK/(0+1)	
	//GPT_SYNCR_Config(GPTA0,0x00,GPT_SYNCUSR0_REARMTrig_DIS,GPT_TRGSRC0_ExtSync_SYNCUSR0,GPT_TRGSRC1_ExtSync_SYNCUSR4,0x3f);//enable SYNCUSR4 SYNCUSR5 as trigger event,continuous mode					
	GPT_PWMX_Output_Control(GPTA0,GPT_PWMA,EPT_CA_Selecte_CMPA,GPT_CB_Selecte_CMPA,GPT_PWM_ZRO_Event_OutHigh,GPT_PWM_PRD_Event_Nochange,GPT_PWM_CAU_Event_OutLow,GPT_PWM_CAD_Event_OutLow,
							GPT_PWM_CBU_Event_Nochange,GPT_PWM_CBD_Event_Nochange,GPT_PWM_T1U_Event_Nochange,GPT_PWM_T1D_Event_Nochange,GPT_PWM_T2U_Event_Nochange,GPT_PWM_T2D_Event_Nochange);
	GPT_PWMX_Output_Control(GPTA0,GPT_PWMB,GPT_CA_Selecte_CMPB,GPT_CB_Selecte_CMPB,GPT_PWM_ZRO_Event_OutHigh,GPT_PWM_PRD_Event_Nochange,GPT_PWM_CAU_Event_OutLow,GPT_PWM_CAD_Event_OutLow,
							GPT_PWM_CBU_Event_Nochange,GPT_PWM_CBD_Event_Nochange,GPT_PWM_T1U_Event_Nochange,GPT_PWM_T1D_Event_Nochange,GPT_PWM_T2U_Event_Nochange,GPT_PWM_T2D_Event_Nochange);
	GPT_PRDR_CMPA_CMPB_Config(GPTA0,4800,2400,1200);//PRDR=4800,CMPA=2400,CMPB=1200
	//GPT_CG_gate_Config(GPTA0,GPT_CGSRC_CHAX,0,0,GPT_BURST_ENABLE);//CG选择CHAX为输入源，CFFLT=PLCK/(0+1),滤波次数Bypass	
//------------  GPTA0 REG LINK  ----------------------------------/		
	//GPT_REG_LINK_CONFIG(GPTA0,GPT_LinkREG_PRDR,GPT_DIS_LINK);//GPTA0->PRDR不链接
	//GPT_REG_LINK_CONFIG(GPTA0,GPT_LinkREG_CMPA,GPT_DIS_LINK);//GPTA0->CMPA不链接
	//GPT_REG_LINK_CONFIG(GPTA0,GPT_LinkREG_CMPB,GPT_DIS_LINK);//GPTA0->CMPB不链接
	//GPT_REG_LINK_CONFIG(GPTA0,GPT_LinkREG_RSSR,GPT_DIS_LINK);//GPTA0->RSSR不链接
//------------  GPTA0 TRGSRC interruption  -----------------------------/	
	//GPT_TRGSRCX_Config(GPTA0,GPT_TRGSRC0,GPT_EVTRG_TRGSRCX_CMPAU,GPT_TRGSRCX_EN,0);//选择CMPAU作为TRGSRC0事件源，事件计数CNT=0
	//GPT_TRGSRCX_Config(GPTA0,GPT_TRGSRC1,GPT_EVTRG_TRGSRCX_CMPBU,GPT_TRGSRCX_EN,0);//选择CMPBU作为TRGSRC1事件源，事件计数CNT=0	
//------------  GPT interruption  --------------------------------/	
	//GPT_Int_Enable(GPTA0,GPT_CAP_LD0);//CMPA load interrupt
	//GPT_Int_Enable(GPTA0,GPT_CAP_LD1);//CMPB load interrupt
	//GPT_Int_Enable(GPTA0,GPT_CAU);//Up-Counting phase CNT = CMPA interrupt request raw status
	//GPT_Int_Enable(GPTA0,GPT_CAD);//Down-Counting phase CNT = CMPA interrupt request raw statu
	//GPT_Int_Enable(GPTA0,GPT_CBU);//Up-Counting phase CNT = CMPB interrupt request raw status
	//GPT_Int_Enable(GPTA0,GPT_CBD);//Down-Counting phase CNT = CMPB interrupt request raw status
	//GPT_Int_Enable(GPTA0,GPT_PEND);//End of cycle interrupt request raw status
	//GPT_Int_Enable(GPTA0,GPT_TRGEV0_INT);//TRGEV0
	//GPT_Int_Enable(GPTA0,GPT_TRGEV1_INT);//TRGEV1
	//GPTA0_Vector_Int_Enable();
//------------  GPTA0 start  --------------------------------/	
	GPT_Start(GPTA0);
//------------  GPTA0 capture config  --------------------------------/
	/*GPT_Soft_Reset(GPTA0);
	GPT_Capture_Config(GPTA0,GPT_Selecte_PCLK,GPT_CNTMD_increase,GPT_CAPMD_Continue,GPT_CAP_EN,GPT_LDARST_EN,GPT_LDBRST_DIS,1,0);//TCLK=pclk/(1+0),CMPAload CMPBload
	GPT_SYNCR_Config(GPTA0,GPT_Triggle_Continue,GPT_SYNCUSR0_REARMTrig_DIS,GPT_TRGSRC0_ExtSync_SYNCUSR0,GPT_TRGSRC1_ExtSync_SYNCUSR4,0x04);//Enable SYNCUSR2 ,Continuous trigger
	GPT_PRDR_CMPA_CMPB_Config(GPTA0,0XFFFFFF,0,0);
	GPT_Int_Enable(GPTA0,GPT_CAP_LD0);//Capture Load to CMPA interrupt request raw status
	GPT_Int_Enable(GPTA0,GPT_CAP_LD1);//Capture Load to CMPB interrupt request raw status
	GPTA0_Vector_Int_Enable();
	GPT_Start(GPTA0);*/
}
/*************************************************************/
//LPT Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void LPT_CONFIG(void)
{
	LPT_DeInit();								//LPT DeInit
	//LPT_IO_Init(LPT_INOUT_PA0_9);				//PA0.9 as output
	LPT_Configure(LPTCLK_EN,LPT_ISCLK,LPT_IMMEDIATE,LPT_PSC_DIV0,0,LPT_OPM_CONTINUOUS);		//
	//LPT_Debug_Mode(ENABLE);
	LPT_ControlSet_Configure(LPT_OUT_EN,LPT_SWSYNDIS,LPT_IDLE_Z,LPT_PRDLD_DUTY_END,LPT_POL_HIGH,LPT_FLTDEB_00,LPT_PSCLD_0,LPT_CMPLD_IMMEDIATELY);
	//LPT_SyncSet_Configure(LPT_TRGEN_EN,LPT_OSTMD_ONCE,LPT_AREARM_DIS);
	//LPT_Trigger_Configure(LPT_SRCSEL_EN,LPT_BLKINV_DIS,LPT_CROSSMD_DIS,LPT_TRGSRC0_CMP,LPT_ESYN0OE_EN,5,5,0X0F);
	LPT_Period_CMP_Write(27000,500);
	LPT_ConfigInterrupt_CMD(ENABLE,LPT_PEND);
	LPT_Start();
	LPT_INT_ENABLE();
}
/*************************************************************/
//BT Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void BT_CONFIG(void)
{
	BT_DeInit(BT0);
	BT_IO_Init(BT0_PB0_2);
	BT_Configure(BT0,BTCLK_EN,0,BT_IMMEDIATE,BT_CONTINUOUS,BT_PCLKDIV);//TCLK=PCLK/(0+1)
	BT_ControlSet_Configure(BT0,BT_START_HIGH,BT_IDLE_LOW,BT_CNTRLD_EN);
	BT_Period_CMP_Write(BT0,48000,240);
	BT_ConfigInterrupt_CMD(BT0,ENABLE,BT_PEND);
	BT0_INT_ENABLE();
	BT_Start(BT0);
	
	BT_DeInit(BT1);
	//BT_IO_Init(BT1_PB0_0);
	BT_Configure(BT1,BTCLK_EN,0,BT_IMMEDIATE,BT_CONTINUOUS,BT_PCLKDIV);
	BT_ControlSet_Configure(BT1,BT_START_LOW,BT_IDLE_HIGH,BT_CNTRLD_EN);
	//BT_Trigger_Configure(BT1,BT_TRGSRC_PEND,BT_TRGOE_EN);
	BT_Period_CMP_Write(BT1,48000,240);
	BT_ConfigInterrupt_CMD(BT1,ENABLE,BT_PEND);
	BT1_INT_ENABLE();
	BT_Start(BT1);
	
	BT_DeInit(BT2);
	BT_Soft_Reset(BT2);
	BT_Configure(BT2,BTCLK_EN,0,BT_IMMEDIATE,BT_CONTINUOUS,BT_PCLKDIV);
	BT_ControlSet_Configure(BT2,BT_START_LOW,BT_IDLE_HIGH,BT_CNTRLD_EN);
	//BT_Trigger_Configure(BT2,BT_TRGSRC_PEND,BT_TRGOE_EN);
	BT_Period_CMP_Write(BT2,48000,240);
	BT_ConfigInterrupt_CMD(BT2,ENABLE,BT_PEND);
	BT2_INT_ENABLE();
	BT_Start(BT2);
	
	BT_DeInit(BT3);
	BT_Configure(BT3,BTCLK_EN,0,BT_IMMEDIATE,BT_CONTINUOUS,BT_PCLKDIV);
	BT_ControlSet_Configure(BT3,BT_START_LOW,BT_IDLE_HIGH,BT_CNTRLD_EN);
	//BT_Trigger_Configure(BT3,BT_TRGSRC_PEND,BT_TRGOE_EN);
	BT_Period_CMP_Write(BT3,48000,24000);
	BT_ConfigInterrupt_CMD(BT3,ENABLE,BT_CMP);
	BT3_INT_ENABLE();
	BT_Start(BT3);
}
/*************************************************************/
//COUNTA Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void COUNTA_CONFIG(void)
{
    COUNT_DeInit();                                                                       //clear all countA Register
    //COUNTA_IO_Init(COUNTA_PB011);                                                                    //set PB0.11 as counter IO
    COUNTA_Init(1000,1000,Period_H,DIV1,REPEAT_MODE,CARRIER_OFF,OSP_LOW);                    //Data_H=Time*2/(1/sysclock),
    COUNTA_Config(SW_STROBE,PENDREM_OFF,MATCHREM_OFF,REMSTAT_0,ENVELOPE_0);               //countA mode set  
    COUNTA_Start();                                                                       //countA start
    //COUNTA_Stop();                                                                      //countA stop  
    COUNTA_Int_Enable();                                                                //countA INT enable
}
/*************************************************************/
//RTC Initial
//EntryParameter:NONE
//ReturnValue:NONE
//RTC CLK=(CLKSRC_EMOSC)/(DIVS+1)/(DIVA+1)/2
//		  (ISCLK)/(DIVS+1)/(DIVA+1)/2
//		  (IMCLK)/(DIVS+1)/(DIVA+1)/2
/*************************************************************/	
void RTC_CONFIG(void)
{
	RTC_RST_VALUE();
	RTC_Stop();												//if you want set time data, must be stop RTC clk.
	//RTC_ALM_IO_SET(Alarm_A_pulse_output);					//PA0.2  1pulse =1 rtc clk
	//RTCCLK_CONFIG(2047,7,CLKSRC_ESOSC);					//32.768K/2/(2047+1)/(7+1)=1S
	RTCCLK_CONFIG(1686,7,CLKSRC_ISOSC);						//27.000K/2/(1686+1)/(7+1)=1S
	RTC_Function_Config(RTC_24H,CPRD_1S);					// RTC Select 24h , CPRD Select 1s
//------------  RTC time data setting ------------------------/	
	RTC_TimeDate_buf.u8Second=0x00;					
	RTC_TimeDate_buf.u8Minute=0x09;
	RTC_TimeDate_buf.u8Hour=0X08;								//24-hour clock
	RTC_TimeDate_buf.u8Day=0X29;
	RTC_TimeDate_buf.u8Month=0X05;
	RTC_TimeDate_buf.u8Year=0X20;
	RTC_TimeDate_buf.u8DayOfWeek=0x04;
	RTC_TIMR_DATR_SET(&RTC_TimeDate_buf);						//20/5/20,14:42:00
//------------  RTC Alarm setting ---------------------------/	
	RTC_AlarmA_buf.u8Second=0x00;							//AlarmA second setting					
	RTC_AlarmA_buf.u8Minute=0x00;							//AlarmA minute setting
	RTC_AlarmA_buf.u8Hour=0X08;								//AlarmA 24-hour setting
	RTC_AlarmA_buf.u8WeekOrData=AL_MonToFri;				//AlarmA day setting Monday to Friday
	RTC_Alarm_TIMR_DATR_SET(Alarm_A,&RTC_AlarmA_buf,
			Alarm_Second_Compare_EN,Alarm_Minute_Compare_EN,Alarm_Hour_Compare_EN);//AlarmA time 08:00:00, week alarm
	
	RTC_AlarmB_buf.u8Second=0x00;							//AlarmB second setting
	RTC_AlarmB_buf.u8Minute=0x00;							//AlarmB minute setting
	RTC_AlarmB_buf.u8Hour=0X09;								//AlarmB 24-hour setting	
	RTC_AlarmB_buf.u8WeekOrData=AL_EVERYDAY;				//AlarmB day setting
	RTC_Alarm_TIMR_DATR_SET(Alarm_B,&RTC_AlarmB_buf,
			Alarm_Second_Compare_EN,Alarm_Minute_Compare_EN,Alarm_Hour_Compare_EN);//AlarmB time 9:00:00, week alarm	
//------------  RTC int setting ---------------------------/		
	//RTC_Int_Enable(ALRA_INT);
	//RTC_Int_Enable(ALRB_INT);
	RTC_Int_Enable(CPRD_INT);
	//RTC_Int_Enable(RTC_TRGEV0_INT);
	//RTC_Int_Enable(RTC_TRGEV1_INT);
	RTC_Vector_Int_Enable();
	RTC_Start();
	//RTC EVT
	//RTC_TRGSRC0_Config(RTC_EVTRG_TRGSRC0_CPRD,RTC_ESYNxOE_EN,1);
	//RTC_TRGSRC1_Config(RTC_EVTRG_TRGSRC1_CPRD,RTC_ESYNxOE_EN,2);	
	//RTC_TRGSRC0_SWFTRG();					//RTC_TRGEV0 	SW SET
	//RTC_TRGSRC1_SWFTRG();					//RTC_TRGEV1 	SW SET
}
/*************************************************************/
//ET Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void ET_CONFIG(void)
{
	ET_DeInit();
	//EXI_SYCN0 -> EPT_SYNIN4
	ET_CH0_SRCSEL(ET_SRC0,ENABLE,ET_EXI_TRGOUT0);
	ET_CH0_CONTROL(ENABLE,TRG_HW,ET_EPT0_SYNCIN4);
	//EXI_SYCN1 -> EPT_SYNIN5
	ET_CH1_SRCSEL(ENABLE,TRG_HW,ET_EXI_TRGOUT1);
	ET_CH1_CONTROL(ET_DST0,ENABLE,ET_EPT0_SYNCIN0);
	ET_ENABLE();
}
/*************************************************************/
//SIO Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void SIO_CONFIG(void)
{
	//********SIO 发送初始化
	/*SIO_DeInit();
	SIO_IO_Init(SIO_PB0_10);
	SIO_TX_Init(SIOCLK_EN,19);//发送模式，FTXCLK=PCLK/(19+1);
	SIO_TX_Configure(SIO_IDLE_HIGH,SIO_TX_MSB,15,15,0,0,SIO_OBH_3BIT,SIO_OBL_3BIT,3,1);
	//空闲高电平，高位到低位输出，发送数据buffer长度15+1，发送序列长度为15，D0时间长度，D1时间长度，DH为3bit，DL为3bit，DH对象定义为011，DL对象定义为001
	//SIO_ConfigInterrupt_CMD(ENABLE,SIO_TXBUFEMPT);
	//SIO_INT_ENABLE();*/
	//********SIO 接收初始化
	SIO_RESET();
	SIO_DeInit();
	SIO_IO_Init(SIO_PB0_10);
	SIO_RX_Init(SIOCLK_EN,SIO_TXDEB_1CYCLE,0);//接收模式，去抖滤波检查周期1CYCLE，FDBCLK=PCLK/(0+1)
	SIO_RX_Configure0(SIO_RX_FALL , SIO_RX_DEB , 3 , 2 , 0 , SIO_RX_ALIGNEN , SIO_RX_MSB , SIO_RMODE1 , 31 , 31 , 4);
	//下降沿触发，选择去抖后采样，bit采样长度(3+1)Rxclk，第2位作为提取，0，使能采样对准，从第0位开始移入，采样模式1无论是否有跳变都进入下个采样，接收长度31+1，接收buf长度31+1，RXCLK=PCLK/(4+1)
	SIO_RX_Configure1(SIO_BREAKEN,SIO_BREAKLVL_HIGH,10,SIO_TORSTDIS,15);
	//使能BREAK，BREAK识别电平为High，11个采样长度，使能采样超时复位，40个采样长度
	//SIO_ConfigInterrupt_CMD(ENABLE,SIO_RXDNE);
	SIO_ConfigInterrupt_CMD(ENABLE,SIO_RXBUFEMPT);
	SIO_ConfigInterrupt_CMD(ENABLE,SIO_BREAK);
	//SIO_ConfigInterrupt_CMD(ENABLE,SIO_TIME);	//不建议使用，数据接收完后，time out失效
	SIO_INT_ENABLE();
}
/*************************************************************/
//SPI MASTER Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void SPI_MASTER_CONFIG(void)
{
	SPI_Reset();
	SPI_DeInit();
	SPI_NSS_IO_Init(1);										//spi NSS io selection
	SPI_Master_Init(SPI_G0,SPI_DATA_SIZE_8BIT,SPI_SPO_0,SPI_SPH_0,SPI_LBM_0,SPI_RXIFLSEL_1_8,0,12);
	//SPI IO group1; 8bis; ; clk low when no data transmission;  first clock edge transition; Normal serial port; Receive Interrupt FIFO Level Selection 1/8; FSSPCLKOUT=48M/12=4M
	SPI_ConfigInterrupt_CMD(ENABLE,SPI_RXIM);				//enable FIFO receive interrupt
	SPI_Int_Enable();										//enable spi interrupt
}
/*************************************************************/
//SPI SLAVE Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void SPI_SLAVE_CONFIG(void)
{
	SPI_Reset();
	SPI_DeInit();
	SPI_NSS_IO_Init(1);										//spi NSS io selection
	SPI_Slave_Init(SPI_G0,SPI_DATA_SIZE_8BIT,SPI_SPH_0,SPI_RXIFLSEL_1_8,0,12);			
	//SPI IO group1; 8bis; first clock edge transition;Receive Interrupt FIFO Level Selection 1/8;FSSPCLKOUT=48M/12=4M
	SPI_ConfigInterrupt_CMD(ENABLE,SPI_RXIM);				//enable FIFO receive interrupt
	SPI_Int_Enable();										//enable spi interrupt
}
/*************************************************************/
//IIC MASTER Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void I2C_MASTER_CONFIG(void)
{
	I2C_RESET();
	//I2C_DeInit();
	I2C_Master_CONFIG(I2C_SDA_PB0_10,I2C_SCL_PB0_11,FAST_MODE,I2C_MASTRER_7BIT,0X57,0X10,0X10);//address=0X57,SCL=IIClk*250=5us
	I2C_SDA_TSETUP_THOLD_CONFIG(0x08,0x40,0x08);										     //TSETUP=0X20*IICLK,RX_THOLD=0X20*IICLK,TX_THOLD=0X20*IICLK
	I2C_FIFO_TriggerData(7,7);
	I2C_Enable();
}
/*************************************************************/
//IIC SLAVER Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/		
void I2C_SLAVE_CONFIG(void)
{
	I2C_RESET();
	//I2C_DeInit();																		   //I2C de-initial
	I2C_Slave_CONFIG(I2C_SDA_PB0_10,I2C_SCL_PB0_11,FAST_MODE,I2C_SLAVE_7BIT,0X57,0X8,0X8);//I2C IO selection,fast mode,slave 7 bit,slave address 0x57(slave address cant set as 0x00~0x07,0x78~0x7f)
	I2C_SDA_TSETUP_THOLD_CONFIG(0x02,0x03,0x08);
	I2C_FIFO_TriggerData(0,0);															  //I2C  FIFO setting
	I2C_ConfigInterrupt_CMD(ENABLE,I2C_SCL_SLOW);										  //I2C interrupt enable/disable
	I2C_ConfigInterrupt_CMD(ENABLE,I2C_STOP_DET);
	I2C_ConfigInterrupt_CMD(ENABLE,I2C_RD_REQ);
	I2C_ConfigInterrupt_CMD(ENABLE,I2C_RX_FULL);
	I2C_ConfigInterrupt_CMD(ENABLE,I2C_TX_ABRT);
	I2C_Enable();
	I2C_Int_Enable();
}
/*************************************************************/
//UART0  CONFIG
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void UART0_CONFIG(void)
{
	UART0_DeInit();                                                //clear all UART Register
    UART_IO_Init(IO_UART0,1);                                     //use PB0.8->TXD0, PB0.9->RXD0
    //UARTInit(UART0,416,UART_PAR_NONE);							  //baudrate=sysclock/416=115200
	UARTInitRxTxIntEn(UART0,416,UART_PAR_NONE);	              	//baudrate=sysclock/416=115200,RX TX int enable
	UART_DMA_Control(UART0,0x02,UART_TX_FL_FIFO_NF,UART_RX_FL_FIFO_NE);
	UART0_Int_Enable();
}	
/*************************************************************/
//UART1  CONFIG
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void UART1_CONFIG(void)
{
	UART1_DeInit();                                                 //clear all UART Register
    UART_IO_Init(IO_UART1,0);                                    	//use PB0.0->TXD1 ,PA0.13->RXD1,
	//UARTInit(UART0,416,UART_PAR_NONE);							 //baudrate=sysclock/416=115200
    UARTInitRxTxIntEn(UART1,416,UART_PAR_NONE);	                    //baudrate=sysclock/416=115200,RX TX int enable
	UART1_Int_Enable();
}	
/*************************************************************/
//UART2  CONFIG
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void UART2_CONFIG(void)
{
	UART2_DeInit();                                                 //clear all UART Register
    UART_IO_Init(IO_UART2,2);                                    	//use PA1.12->RXD2, PA1.11->TXD2 
	//UARTInit(UART0,416,UART_PAR_NONE);							  //baudrate=sysclock/416=115200
    UARTInitRxTxIntEn(UART2,416,UART_PAR_NONE);	                    //baudrate=sysclock/416=115200,RX TX int enable
	UART2_Int_Enable();
}	 
/*************************************************************/
//USART Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void USART_CONFIG(void)
{
	USART_DeInit();                                                              	//USART 所有寄存器复位赋值
    USART_CLK_Enable();																//USART CLK	使能
	USART_CTRL_Config(RSTRX,ENABLE);												//复位接收模块
	USART_CTRL_Config(RSTTX,ENABLE);												//复位发射模块
	USART_DMA_Control(0X03,USART_TX_FL_FIFO_NF,USART_RX_FL_FIFO_NE);
	USART_IO_Init(USART_TxPB0_10_RxPB0_11);                                          //USART 使用PB0.10->TXD, PB0.11->RXD
	//USART_CLKIO_Init(CLK_PB0_8);													//同步模式下可以选择PB0.8作为UARTCLK
    USART_MODE_Config(LSBtoMSB,PCLK,CHRL8,ASYNC,PAR_NONE,NBSTOP1,
				CHMODE_NORMAL,USART_FIFO_DIS,USART_FIFO_TRIG_1_2);//低位->高位发送模式,UsartCLK=PCLK,字节长度8bit, 异步模式, 偶校验位, 1个停止位, 普通模式,FIFO使能,接收>1/2 FIFO
	//USART_CLKO_Config(ENABLE);														//同步模式下需要输出UARTCLK时,需要使能
    USART_Baudrate_Cal(115200,48000000,PCLK,ASYNC);									//波特率=115200, 主频选择48M, PCLK不分频, 异步模式							
	USART_CTRL_Config(TXEN,ENABLE);													//USART 发送使能
	USART_CTRL_Config(RXEN,ENABLE);													//USART 接收使能
	USART_INT_Config(USART_RXRDY_INT,ENABLE);												//USART 接收中断使能
	//USART_INT_Config(USART_TXRDY_INT,ENABLE);												//USART 发射中断使能	
	USART_Int_Enable();																//USART 中断向量使能
}
/*************************************************************/
//adc config
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void ADC12_CONFIG(void)
{
	ADC12_Software_Reset();
	ADC12_CLK_CMD(ADC_CLK_CR , ENABLE);                                         //enable ADC CLK
	ADC12_Configure_Mode(ADC12_12BIT , One_shot_mode ,0, 16 ,2 , 1);           //12BIT ADC; Continuous mode; Conversion priority selection 0; Holding cycles=6 ;ADC_CLK=PCLK/2*2=0.2us; Number of Conversions=1
	ADC12_Configure_VREF_Selecte(ADC12_VREFP_VDD_VREFN_VSS);					    //ADC VREF Positive FVR4.096V,negative VSS
	ADC12_ConversionChannel_Config(ADC12_ADCIN17,ADC12_CV_RepeatNum16,ADC12_AVGEN,0);    //SEQ0 chose ADCIN0, 6 Holding cycles, Average 1 time
	//ADC12_ConversionChannel_Config(ADC12_INTVREF,ADC12_CV_RepeatNum1,ADC12_AVGDIS,1);  //SEQ1 chose ADCIN1, 6 Holding cycles , Average 1 time
	ADC12_CMD(ENABLE);                                                                  //enable ADC
	ADC12_ready_wait(); 																//wait ADC get ready
	ADC12_Control(ADC12_START);															//ADC convert start
}
/*************************************************************/
//touch config
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void TK_CONFIG(void)
{
	tkey_init();
	tkey_basetime_init(10);
}
/*************************************************************/
//syscon Functions
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void SYSCON_CONFIG(void)
{
//------SYSTEM CLK AND PCLK FUNTION---------------------------/
	SYSCON_RST_VALUE();                                                         //SYSCON all register clr
	SYSCON_General_CMD(ENABLE,ENDIS_ISOSC);
	//EMOSC_OSTR_Config(0XAD,0X1f,EM_LFSEL_EN,EM_FLEN_EN,EM_FLSEL_10ns);			//EM_CNT=0X3FF,0xAD(36K),EM_GM=0,Low F modedisable,EM filter disable,if enable,cont set 5ns
	//EMOSC_OSTR_Config(0XAD,0X0f,EM_LFSEL_EN,EM_FLEN_EN,EM_FLSEL_10ns);			//晶振起振之后减小GM可以降低功率
	//SYSCON_General_CMD(ENABLE,ENDIS_EMOSC);
	SYSCON_HFOSC_SELECTE(HFOSC_SELECTE_48M);									//HFOSC selected 48MHz
	SystemCLK_HCLKDIV_PCLKDIV_Config(SYSCLK_HFOSC,HCLK_DIV_1,PCLK_DIV_1,HFOSC_48M);//system clock set, Hclk div ,Pclk div  set system clock=SystemCLK/Hclk div/Pclk div
//------------  WDT FUNTION  --------------------------------/
    SYSCON_IWDCNT_Config(IWDT_TIME_2S,IWDT_INTW_DIV_7);      					//WDT TIME 1s,WDT alarm interrupt time=1s-1s*1/8=0.875S
    SYSCON_WDT_CMD(ENABLE);                                                  	//enable WDT		
    SYSCON_IWDCNT_Reload();                                                   	//reload WDT
	//IWDT_Int_Enable();
//------------  WWDT FUNTION  --------------------------------/
	//WWDT_CNT_Load(0xFF);
	//WWDT_CONFIG(PCLK_4096_DIV0,0xFF,WWDT_DBGDIS);
	//WWDT_Int_Config(ENABLE);
	//WWDT_CMD(ENABLE);
//------------  CLO  --------------------------------/	
	//SYSCON_CLO_CONFIG(CLO_PA08);												//CLO output setting
	//SYSCON_CLO_SRC_SET(CLO_HFCLK,CLO_DIV8);									//CLO output clock and div
//------------  LVD FUNTION  --------------------------------/ 
    SYSCON_LVD_Config(DISABLE_LVDEN,INTDET_LVL_3_3V,RSTDET_LVL_1_9V,INTDET_POL_fall);   //LVD LVR Enable/Disable
    //LVD_Int_Enable();
//------------  SYSCON Vector  --------------------------------/ 	
	//SYSCON_VectorInt_Enable();    														//SYSCON VECTOR
}
/*********************************************************************************/  
/*********************************************************************************/
//APT32F102_init                                                                  /
//EntryParameter:NONE                                                             /
//ReturnValue:NONE                                                                /
/*********************************************************************************/
/*********************************************************************************/  
/*********************************************************************************/
void APT32F103_init(void) 
{
//------------------------------------------------------------/
//Peripheral clock enable and disable
//EntryParameter:NONE
//ReturnValue:NONE
//------------------------------------------------------------/
	SYSCON->IDCCR=(0xE11E<<16)|0X01;
	do
	{
		SYSCON->PCER0=0x005127d1;                                        //PCLK Enable  
		SYSCON->PCER1=0xc0023f80;                                        //PCLK Enable
	}
    while(!(((SYSCON->PCSR0&0x005127d1)==0x005127d1)
			&&((SYSCON->PCSR1&0xc0023f80)==0xc0023f80)));               //Wait PCLK enabled	
//------------------------------------------------------------/
//ISOSC/IMOSC/EMOSC/SYSCLK/IWDT/LVD/EM_CMFAIL/EM_CMRCV/CMD_ERR OSC stable interrupt
//EntryParameter:NONE
//ReturnValue:NONE
//------------------------------------------------------------/
    SYSCON_CONFIG();                                                 //syscon  initial
	All_IntVector_initial();										 //默认1
	//Set_INT_Priority(BT3_IRQ_NUM,2);								 //值越大优先级越高
	CK_CPU_EnAllNormalIrq();                                         //enable all IRQ
//------------------------------------------------------------/
//Other IP config
//------------------------------------------------------------/
	//GPIO_CONFIG();                                                //GPIO initial   
	//EPT0_CONFIG();                                                //EPT0 initial 
	//GPTA0_CONFIG();												//GPT0 initial
	//LPT_CONFIG();													//LPT initial	
	//BT_CONFIG();													//BT initial
	//COUNTA_CONFIG();                                              //CountA initial	
	//RTC_CONFIG();													//RCT initial		              
    //I2C_MASTER_CONFIG();                                          //I2C harware master initial 
	//I2C_SLAVE_CONFIG();                                           //I2C harware slave initial 
	//SPI_MASTER_CONFIG();											//SPI Master initial 	
	//SPI_SLAVE_CONFIG();											//SPI Slaver initial 
	//SIO_CONFIG();													//SIO initial
    //UART0_CONFIG();                                               //UART0 initial 
	//UART1_CONFIG();                                               //UART1 initial 
	//UART2_CONFIG();                                               //UART2 initial 
	//USART_CONFIG();												//USART0 initial
	//ADC12_CONFIG();                                               //ADC initial 
	//TK_CONFIG();													//Tkey initial
}
/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/