/*
  ******************************************************************************
  * @file    apt32f103_et.h
  * @author 
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */
 
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef _apt32f103_et_H
#define _apt32f103_et_H

/* Includes ------------------------------------------------------------------*/
#include "apt32f103.h"


#define ET_RESET_VALUE  (0x00000000)
//--------------------------------------------------------------------------------
//-----------------------------ET  value enum define--------------------------
//--------------------------------------------------------------------------------
/**
  * @brief  ET SWTRG register
  */
typedef enum
{
    ET_SWTRG_CH0 = 1,
	ET_SWTRG_CH1 = (1<<1),
	ET_SWTRG_CH2 = (1<<2),
	ET_SWTRG_CH3 = (1<<3),
	ET_SWTRG_CH4 = (1<<4),
	ET_SWTRG_CH5 = (1<<5),
	ET_SWTRG_CH6 = (1<<6),
	ET_SWTRG_CH7 = (1<<7),
	ET_SWTRG_CH8 = (1<<8),
	ET_SWTRG_CH9 = (1<<9),
	ET_SWTRG_CH10 = (1<<10),
	ET_SWTRG_CH11 = (1<<11)
}CRC_ETSWTRG_TypeDef;
/**
  * @brief  SRCSEL register
  */
typedef enum
{
    ET_SRC0 = 0,
	ET_SRC1 = 1,
	ET_SRC2 = 2,
}CRC_ESRCSEL_TypeDef;
/**
  * @brief  SRCSEL register
  */
typedef enum
{
    ET_DST0 = 0,
	ET_DST1 = 1,
	ET_DST2 = 2,
}CRC_DSTSEL_TypeDef;
/**
  * @brief  SRCSEL register
  */
typedef enum
{
    ET_CH3 = 0,
	ET_CH4 = 1,
	ET_CH5 = 2,
	ET_CH6 = 3,
	ET_CH7 = 4,
	ET_CH8 = 5,
	ET_CH9 = 6,
	ET_CH10 = 7,
	ET_CH11 = 8
}CRC_ETCHX_TypeDef;
/**
  * @brief  TRIG MODE register
  */
typedef enum
{
    TRG_HW = (0X00<<1),
	TRG_SW = (0X01<<1),
}CRC_TRIGMODE_TypeDef;

typedef enum
{
	DMA_DIS = (0X00<<2),
	DMA_EN = (0X01<<2)
}DMA_CMD_TypeDef;


//Source IP Event
#define ET_LPT_TRGOUT0  (0X0)
#define ET_EXI_TRGOUT0  (0X4)
#define ET_EXI_TRGOUT1  (0X5)
#define ET_EXI_TRGOUT2  (0X6)
#define ET_EXI_TRGOUT3  (0X7)
#define ET_EXI_TRGOUT4  (0X8)
#define ET_EXI_TRGOUT5  (0X9)
#define RTC_TRGOUT0		(0XA)
#define RTC_TRGOUT1		(0XB)
#define ET_BT0_SYNC0  	(0XA)
#define ET_BT1_SYNC0  	(0XB)
#define ET_EPT0_TRGOUT0  (0X10)
#define ET_EPT0_TRGOUT1  (0X11)
#define ET_EPT0_TRGOUT2  (0X12)
#define ET_EPT0_TRGOUT3  (0X13)
#define ET_SIO0_TXSRC	 (0X1C)
#define ET_SIO0_RXSRC	 (0X1D)
#define ET_GPTA0_TRGOUT0 (0X20)
#define ET_GPTA0_TRGOUT1 (0X21)
#define ET_I2C_TXSRC	(0X24)
#define ET_I2C_RXSRC	(0X25)
#define ET_SPI0_TXSRC   (0X28)
#define ET_SPI0_RXSRC   (0X29)
#define ET_ADC_TRGOUT0  (0X30)
#define ET_ADC_TRGOUT1  (0X31)
#define ET_UART0_TXSRC 	(0X34)
#define ET_UART0_RXSRC 	(0X35)
#define ET_UART1_TXSRC 	(0X36)
#define ET_UART1_RXSRC 	(0X37)
#define ET_UART2_TXSRC 	(0X38)
#define ET_UART2_RXSRC 	(0X39)
#define ET_USART0_TXSRC 	(0X3A)
#define ET_USART0_RXSRC 	(0X3B)
#define ET_TKEY_TRGOUT  (0X3C)

//Destination IP Event
#define ET_LPT_SYNCIN0	  (0X0)
#define ET_BT0_SYNCIN0    (0X2)
#define ET_BT0_SYNCIN1    (0X3)
#define ET_BT0_SYNCIN2    (0X4)
#define ET_ADC_SYNCIN0    (0X6)
#define ET_ADC_SYNCIN1    (0X7)
#define ET_ADC_SYNCIN2    (0X8)
#define ET_ADC_SYNCIN3    (0X9)
#define ET_ADC_SYNCIN4    (0XA)
#define ET_ADC_SYNCIN5    (0XB)
#define ET_BT1_SYNCIN0    (0XC)
#define ET_BT1_SYNCIN1    (0XD)
#define ET_BT1_SYNCIN2    (0XE)
#define ET_EPT0_SYNCIN0   (0X10)
#define ET_EPT0_SYNCIN1   (0X11)
#define ET_EPT0_SYNCIN2   (0X12)
#define ET_EPT0_SYNCIN3   (0X13)
#define ET_EPT0_SYNCIN4   (0X14)
#define ET_EPT0_SYNCIN5   (0X15)
#define ET_BT2_SYNCIN0    (0X18)
#define ET_BT2_SYNCIN1    (0X19)
#define ET_BT2_SYNCIN2    (0X1A)
#define ET_BT3_SYNCIN0    (0X20)
#define ET_BT3_SYNCIN1    (0X21)
#define ET_BT3_SYNCIN2    (0X22)
#define ET_GPTA0_SYNCIN0  (0X24)
#define ET_GPTA0_SYNCIN1  (0X25)
#define ET_GPTA0_SYNCIN2  (0X26)
#define ET_GPTA0_SYNCIN3  (0X27)
#define ET_GPTA0_SYNCIN4  (0X28)
#define ET_GPTA0_SYNCIN5  (0X29)
#define ET_DMA_CH0		  (0X30)
#define ET_DMA_CH1		  (0X31)
#define ET_DMA_CH2		  (0X32)
#define ET_DMA_CH3		  (0X33)
#define ET_DMA_CH4		  (0X34)
#define ET_DMA_CH5		  (0X35)
#define ET_TOUCH_SYNCIN	  (0X3C)


extern void ET_DeInit(void);
extern void ET_ENABLE(void);
extern void ET_DISABLE(void);
extern void ET_SWTRG_CMD(CRC_ETSWTRG_TypeDef ETSWTRG_X,FunctionalStatus NewState);
extern void ET_CH0_SRCSEL(CRC_ESRCSEL_TypeDef ESRCSEL_X,FunctionalStatus NewState,U8_T SRCSEL_X);
extern void ET_CH0_CONTROL(FunctionalStatus NewState,CRC_TRIGMODE_TypeDef TRIGMODEX,U8_T DSTSEL_X);
extern void ET_CH1_SRCSEL(FunctionalStatus NewState,CRC_TRIGMODE_TypeDef TRIGMODEX,U8_T SRCSEL_X);
extern void ET_CH1_CONTROL(CRC_DSTSEL_TypeDef DST_X,FunctionalStatus NewState,U8_T DSTSEL_X);
extern void ET_CH2_SRCSEL(FunctionalStatus NewState,CRC_TRIGMODE_TypeDef TRIGMODEX,U8_T SRCSEL_X);
extern void ET_CH2_CONTROL(CRC_DSTSEL_TypeDef DST_X,FunctionalStatus NewState,U8_T DSTSEL_X);
extern void ET_CH3_SRCSEL(FunctionalStatus NewState,CRC_TRIGMODE_TypeDef TRIGMODEX,U8_T SRCSEL_X);
extern void ET_CH3_CONTROL(CRC_DSTSEL_TypeDef DST_X,FunctionalStatus NewState,U8_T DSTSEL_X);
extern void ET_CHx_CONTROL(CRC_ETCHX_TypeDef ETCHX,FunctionalStatus NewState,DMA_CMD_TypeDef DMA_CMD,CRC_TRIGMODE_TypeDef TRIGMODEX,U8_T SRCSEL_X,U8_T DSTSEL_X);


#endif   

/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/